/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.context;

/**
 * Uniquely identifies of an entity instance
 * @author Lin Liang
 */

public final class Identity {
    private final Object id;

    private final String entityName;

    private final int hashCode;

    public Identity(Object id, String entityName) {
        this.id = id;
        this.entityName = entityName;
        hashCode = getHashCode();
    }

    @Override
    public boolean equals(Object other) {
        Identity otherId = (Identity) other;
        return otherId.entityName.equals(this.entityName) && otherId.id.equals(this.id);
    }

    private int getHashCode() {
        int result = 17;
        result = 37 * result + entityName.hashCode();
        result = 37 * result + id.hashCode();
        return result;
    }

    @Override
    public int hashCode() {
        return hashCode;
    }

    public Object getId() {
        return id;
    }
}
