/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.context;

import org.ow2.xplus.context.state.CascadeFindState;
import org.ow2.xplus.context.state.GoneState;
import org.ow2.xplus.context.state.ManagedState;
import org.ow2.xplus.context.state.DeletedState;
import org.ow2.xplus.context.state.DirtyState;
import org.ow2.xplus.context.state.FetchState;
import org.ow2.xplus.context.state.TransientState;

/**
 * manage the state of each entities
 * @author Lin Liang
 */

public final class StateManager {

    private static EntityState managedState;

    private static EntityState deletedState;

    private static EntityState dirtyState;

    private static EntityState fetchState;

    private static EntityState transientState;
    
    private static EntityState goneState;
    
    private static EntityState CascadeFindState;

    public StateManager() {
    	managedState = new ManagedState(this);
        deletedState = new DeletedState(this);
        dirtyState = new DirtyState(this);
        fetchState = new FetchState(this);
        transientState = new TransientState(this);
        goneState = new GoneState(this);
        CascadeFindState = new CascadeFindState(this);
    }

    public EntityState getCleanState() {
        return managedState;
    }

    public EntityState getDeletedState() {
        return deletedState;
    }

    public EntityState getDirtyState() {
        return dirtyState;
    }

    public EntityState getFetchState() {
        return fetchState;
    }

    public EntityState getTransientState() {
        return transientState;
    }
    public EntityState getGoneState() {
    	return goneState;
    }
    public EntityState getCascadeFindState(){
    	return CascadeFindState;
    }
}
