/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.datasvc;

import java.sql.SQLException;

import javax.sql.DataSource;

/**
 * @author Lin Liang
 */

public abstract class AbstractDataSource implements DataSource {

    protected DataSource dataSource = null;
    
//    private Map<String, String> dialects = new HashMap<String, String>();

    public AbstractDataSource() {
//         dialects.put("org.axiondb.jdbc.AxionDriver", "Axion");
//         dialects.put("com.ibm.db2.jcc.DB2Driver", "DB2");
//         dialects.put("COM.ibm.db2os390.sqlj.jdbc.DB2SQLJDriver", "DB2");
//         dialects.put("COM.ibm.db2.jdbc.app.DB2Driver", "DB2");
//         dialects.put("org.apache.derby.jdbc.ClientDriver", "Derby");
//         dialects.put("org.apache.derby.jdbc.EmbeddedDriver", "Derby");
//         dialects.put("org.firebirdsql.jdbc.FBDriver", "Firebird");
//         dialects.put("org.hsqldb.jdbcDriver", "HsqlDb");
//         dialects.put("interbase.interclient.Driver", "Interbase");
//         dialects.put("com.mckoi.JDBCDriver", "McKoi");
//         dialects.put("com.microsoft.jdbc.sqlserver.SQLServerDriver", "MsSql");
//         dialects.put("com.microsoft.sqlserver.jdbc.SQLServerDriver", "MsSql"); 
//         dialects.put("com.mysql.jdbc.Driver", "MySQL");
//         dialects.put("org.gjt.mm.mysql.Driver", "MySQL");
//         dialects.put("oracle.jdbc.driver.OracleDriver", "Oracle9");
//         dialects.put("oracle.jdbc.dnlddriver.OracleDriver", "Oracle");
//         dialects.put("org.postgresql.Driver", "PostgreSql");
//         dialects.put("com.sap.dbtech.jdbc.DriverSapDB", "SapDB");
//         dialects.put("com.sybase.jdbc2.jdbc.SybDriver", "Sybase");
//         dialects.put("com.sybase.jdbc.SybDriver", "Sybase");
    }

    public String getDatabaseName() {
        String name = "";
        try {
            name = dataSource.getConnection().getCatalog();
            if (name == null) {
            	String url = dataSource.getConnection().getMetaData().getURL();
            	int index = url.lastIndexOf(':');
            	if (index > 0) name = url.substring(index + 1);
            	else {
            		index = url.lastIndexOf('\\');
            		if (index > 0) name = url.substring(index + 1);
            	}
            }
        } catch (SQLException se) {
            se.printStackTrace();
        }
        return name;
    }
}
