/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.datasvc.connection;

import java.util.Properties;

import javax.sql.DataSource;

import org.ow2.xplus.datasvc.ConnectionManager;
import org.ow2.xplus.deployer.PersistenceXMLParser;

/**
 * @author Lin Liang
 */

public class JonasConnection implements ConnectionManager {

    public DataSource getDataSource(Properties props) {

        DataSource dataSource = null;
        try {
            Class clazz = Class.forName("org.objectweb.easybeans.component.jdbcpool.ConnectionManager");
            dataSource = (DataSource) clazz.newInstance();

            clazz.getMethod("setClassName", String.class).invoke(
                    props.getProperty(PersistenceXMLParser.PERSISTENCE_CONNECTION_DRIVERCLASS));
            clazz.getMethod("setUrl", String.class).invoke(props.getProperty(PersistenceXMLParser.PERSISTENCE_CONNECTION_URL));
            clazz.getMethod("setUserName", String.class).invoke(
                    props.getProperty(PersistenceXMLParser.PERSISTENCE_CONNECTION_USER));
            clazz.getMethod("setPassword", String.class).invoke(
                    props.getProperty(PersistenceXMLParser.PERSISTENCE_CONNECTION_PASSWORD));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return dataSource;
    }
}
