/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.descriptor;

import java.util.List;

import org.jdom.Element;

/**
 * abstract implement of descriptor
 * @author Lin Liang
 */

public abstract class AbstractDescriptor implements Descriptor {
    /**
     * get table element with the given name
     * @param databaseElem the root database element
     * @param tableName the name of the table
     * @return table element with the given name
     */
    protected Element getTableElement(Element databaseElem, String tableName) {
        Element table = null;

        List tableElems = databaseElem.getChildren(DescriptorTag.TABLE);
        for (int index = 0; index < tableElems.size(); ++index) {
            Element tableElem = (Element) tableElems.get(index);
            if (tableElem.getAttribute(DescriptorTag.NAME).getValue().equals(tableName)) {
                table = tableElem;
                break;
            }

        }

        if (table == null) {
            table = new Element(DescriptorTag.TABLE);
            table.setAttribute(DescriptorTag.NAME, tableName);
            databaseElem.addContent(table);
        }
        return table;
    }
}
