/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.exception;

/**
 * This exception is used for any problem that is detected while EJBQL parsing.
 * @author Lin Liang
 */

@SuppressWarnings("serial")
public class EjbqlParserException extends PkuPersistenceException {

    public static final int EJBQL_LEXER_SCANER_ERROR = 301;

    public static final int EJBQL_PARSER_RECOGNITION_ERROR = 302;

    public static final int EJBQL_PARSER_GRAMMER_ERROR = 303;

    public static final int EJBQL_PARSER_SEMANTIC_ERROR = 304;

    public static final int EJBQL_PARSER_SYNTAX_ERROR = 305;

    public EjbqlParserException(Throwable cause, int errorCode) {
        super(cause, errorCode);
    }

    public EjbqlParserException(String message, int errorCode) {
        super(message, errorCode);
    }

}
