/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.exception;

import javax.persistence.PersistenceException;

import org.ow2.xplus.logger.LogFactory;
import org.ow2.xplus.logger.Logger;

/**
 * Any exception raised by PkuPersistence is a subclass of this exception class.
 * @author Lin Liang
 */

public abstract class PkuPersistenceException extends PersistenceException {
    private Logger logger = LogFactory.getLogger(PkuPersistenceException.class);

    protected int errorCode = 0;

    public PkuPersistenceException(Throwable cause, int errorCode) {
        super(cause);
        this.errorCode = errorCode;
    }

    public PkuPersistenceException(String message, int errorCode) {
        super(message);
        this.errorCode = errorCode;
    }

    @Override
    public String toString() {
        return ("error occurs with message: " + getMessage() + ", error code: " + errorCode);
    }

    public void showMessage() {
        logger.error(toString());
        if (this.getCause() != null)
            this.getCause().printStackTrace();
    }

    public int getErrorCode() {
        return errorCode;
    }

    public void setErrorCode(int errorCode) {
        this.errorCode = errorCode;
    }

}
