/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.exception;

/**
 * This exception is used for any problem that is detected while accessing the
 * property of a entity.
 * @author Lin Liang
 */

@SuppressWarnings("serial")
public class PropertyAccessException extends PkuPersistenceException {

    public static final int ILLEGAL_ARGUMENT_ERROR = 601;

    public static final int ILLEGAL_ACCESS_ERROR = 602;

    public static final int INVOCATION_TARGET_ERROR = 603;

    public static final int NO_SUCH_FIELD_ERROR = 604;

    public static final int SECURITY_ERROR = 605;

    public static final int INSTANTIATION_ERROR = 606;

    public PropertyAccessException(Throwable cause, int errorCode) {
        super(cause, errorCode);
    }

    public PropertyAccessException(String message, int errorCode) {
        super(message, errorCode);
    }

}
