/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.logger;

import java.lang.reflect.Constructor;

import org.ow2.xplus.logger.pluggin.ApacheLogger;

/**
 * the factory used to get logger
 * @author Lin Liang
 */

public class LogFactory {

    public static String loggerName = "org.ow2.xplus.logger.pluggin.ApacheLogger";

    public static synchronized Logger getLogger(Class clazz) {
        Logger logger = null;
        try {
            Class loggerClass = Class.forName(loggerName);
            Constructor constructor = loggerClass.getConstructor(Class.class);
            if (constructor == null)
                constructor = loggerClass.getConstructor();
            if (constructor != null)
                logger = (Logger) constructor.newInstance(clazz);
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (logger == null)
            logger = new ApacheLogger(clazz);
        return logger;
    }

}
