/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.logger;

/**
 * the interface of logger
 * @author Lin Liang
 */

public interface Logger {

    /**
     * Output the debug information
     * @param s The message to log
     */
    public void debug(String s);

    /**
     * Output the error information
     * @param s The message to log
     */
    public void error(String s);

    /**
     * Output the info information
     * @param s The message to log
     */
    public void info(String s);

    /**
     * Output the warning information
     * @param s The message to log
     */
    public void warning(String s);

}
