/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.object;

import java.util.ArrayList;
import java.util.List;

/**
 * Abstract implement of the Collection Value
 * @author Lin Liang
 */

public class AbstractCollectionValue implements CollectionValue {
    private List<String> ascOrderingProperty = new ArrayList<String>();

    private List<String> descOrderingProperty = new ArrayList<String>();

    /**
     * the map key for associations of type java.util.Map.
     */
    private String mappedPropertyName;

    private String collectionTableName;

    public String getMappedPropertyName() {
        return mappedPropertyName;
    }

    public void setMappedPropertyName(String mappedPropertyName) {
        this.mappedPropertyName = mappedPropertyName;
    }

    public void addOrderBy(String propertyName, String ordering) {
        if (ordering.equals(ASC)) {
            ascOrderingProperty.add(propertyName);
        } else {
            descOrderingProperty.add(propertyName);
        }
    }

    public String getCollectionTableName() {
        return collectionTableName;
    }

    public void setCollectionTableName(String collectionTableName) {
        this.collectionTableName = collectionTableName;
    }
}
