/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.object;

import javax.persistence.CascadeType;
import javax.persistence.ManyToOne;

import org.ow2.xplus.mapping.annotation.Member;
import org.ow2.xplus.metadata.relational.RdbRelation;

/**
 * ManyToOne relation
 * @author Lin Liang
 */

public class ManyToOneRelation extends AbstractRelation {

    public ManyToOneRelation(Member member, ManyToOne manyToOne) {
        targetEntity = manyToOne.targetEntity().equals(void.class) ? member.getParameterizedType() : manyToOne.targetEntity();

        if (manyToOne.cascade().length != 0) {
            for (CascadeType cascadeType : manyToOne.cascade()) {
                cascade.add(cascadeType);
            }
        }

        fetch = manyToOne.fetch();
        optional = manyToOne.optional();
    }

    public RdbRelation buildInverseRelation(String unitName, String proprtyTypeName) {
        return null;
    }
}
