/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.object;

import java.util.ArrayList;
import java.util.List;

import org.ow2.xplus.metadata.relational.RdbColumn;

/**
 * @author Lin Liang
 */

public class SimpleValue {
    /**
     * the columns uses to store the value
     */
    private List<RdbColumn> columns = new ArrayList<RdbColumn>();

    /**
     * whether it is a embedded value
     */
    private boolean embedded = false;

    /**
     * whether it is an id
     */
    private boolean id = false;

    private String embeddedClassName;

    public List<RdbColumn> getColumns() {
        return columns;
    }

    public boolean isEmbedded() {
        return embedded;
    }

    public void setEmbedded(boolean embedded) {
        this.embedded = embedded;
    }

    public String getEmbeddedClassName() {
        return embeddedClassName;
    }

    public void setEmbeddedClassName(String embeddedClassName) {
        this.embeddedClassName = embeddedClassName;
    }

    public void addColumn(RdbColumn column) {
        columns.add(column);
    }

    public boolean isId() {
        return id;
    }

    public void setId(boolean id) {
        this.id = id;
    }
}
