/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.query;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Lin Liang
 */

public class EntityMapping {

    private Class entityClass;

    private List<FieldMapping> fields = new ArrayList<FieldMapping>();

    private String discriminatorColumn;

    public EntityMapping(Class entityClass) {
        this.entityClass = entityClass;
    }

    public String getDiscriminatorColumn() {
        return discriminatorColumn;
    }

    public void setDiscriminatorColumn(String discriminatorColumn) {
        this.discriminatorColumn = discriminatorColumn;
    }

    public Class getEntityClass() {
        return entityClass;
    }

    public List<FieldMapping> getFields() {
        return fields;
    }

    public void addFieldMapping(FieldMapping field) {
        fields.add(field);
    }

}
