/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.relational;

import javax.persistence.GenerationType;

import org.ow2.xplus.metadata.strategy.GeneratorStrategy;

/**
 * relation db id generator
 * @author Lin Liang
 */

public class RdbIdGenerator {
    private String name;

    /**
     * The primary key generation strategy that the persistence provider must
     * use to generate the annotated entity primary key.
     */
    private GenerationType strategyType;

    /**
     * The strategy of the primary key generator
     */
    private GeneratorStrategy generatorStrategy = null;

    public RdbIdGenerator() {
    }

    public RdbIdGenerator(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setName(String generatorName) {
        this.name = generatorName;
    }

    public GenerationType getStrategyType() {
        return strategyType;
    }

    public void setStrategyType(GenerationType strategyType) {
        this.strategyType = strategyType;
    }

    public GeneratorStrategy getGeneratorStrategy() {
        return generatorStrategy;
    }

    public void setGeneratorStrategy(GeneratorStrategy generatorStrategy) {
        this.generatorStrategy = generatorStrategy;
    }
}
