/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.relational;

import java.util.ArrayList;
import java.util.List;

/**
 * joined key used in inheritance
 * @author Lin Liang
 */

public class RdbInheritanceJoinedKey {
    /**
     * the name of inheritance entity (parent)
     */
    private String inheritanceEntityName;

    /**
     * the primary table name of inheritance entity (parent)
     */
    private String inheritanceEntityTableName;

    /**
     * names of join columns
     */
    private List<String> joinColumnNames = new ArrayList<String>();

    /**
     * names of referenced columns
     */
    private List<String> referencedColumnNames = new ArrayList<String>();

    public RdbInheritanceJoinedKey() {
    }

    public void addcolumnMaping(String joinColumnName, String referencedColumnName) {
        joinColumnNames.add(joinColumnName.toUpperCase());
        referencedColumnNames.add(referencedColumnName.toUpperCase());
    }

    public List<String> getJoinColumnNames() {
        return joinColumnNames;
    }

    public void setJoinColumnNames(List<String> joinColumnNames) {
        this.joinColumnNames = joinColumnNames;
    }

    public List<String> getReferencedColumnNames() {
        return referencedColumnNames;
    }

    public void setReferencedColumnNames(List<String> referencedColumnNames) {
        this.referencedColumnNames = referencedColumnNames;
    }

    public String getInheritanceEntityName() {
        return inheritanceEntityName;
    }

    public void setInheritanceEntityName(String inheritanceEntityName) {
        this.inheritanceEntityName = inheritanceEntityName;
    }

    public String getInheritanceEntityTableName() {
        return inheritanceEntityTableName;
    }

    public void setInheritanceEntityTableName(String inheritanceEntityTableName) {
        this.inheritanceEntityTableName = inheritanceEntityTableName;
    }
}
