/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.relational;

/**
 * @author Lin Liang
 */

public interface RdbRelation {
    /**
     * @return the name of referenced entity
     */
    public String getReferencedEntityName();

    /**
     * @return the primary table name of referenced entity
     */
    public String getReferencedTableName();

    /**
     * used to determine whether it's a inverse relation
     * @return true if it's a inverse relation
     */
    public boolean isInverse();

    /**
     * bind embedded columns to mapping
     * @param unitName the name of persistence unit contains this entity
     * @param fieldName the field holds the relation
     * @param ownerTableName the name of the relation owner's primary table
     */
    public void bindEmbeddedColumn(String unitName, String fieldName, String ownerTableName);

    /**
     * @return the name of the owner of the relation
     */
    public String getOwnerTableName();

    /**
     * set the name of the owner of the relation
     * @param ownerTableName the name of the owner of the relation
     */
    public void setOwnerTableName(String ownerTableName);
}
