/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.strategy;

/**
 * strategy used to specify the value of the discriminator column for entities
 * of the given type
 * @author Lin Liang
 */

public interface DiscriminatorStrategy {
    /**
     * @param className the entity class name
     * @return The value that indicates that the row is an entity of the
     *         annotated entity type.
     */
    public Object getValue(String className);

    /**
     * @return SQL type of Discriminator column
     */
    public String getSqlType();

    /**
     * @return Java type of Discriminator column
     */
    public Class getJavaType();
}
