/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.strategy;

/**
 * the inheritance strategy to be used for an entity class hierarchy
 * @author Lin Liang
 */

public interface InheritanceStrategy {
    /**
     * get primary table name of the entity class
     * @param className the name of entity class
     * @return primary table name of the entity class
     */
    public String getTableName(String unitName, String className);

    /**
     * used to determine whether to igonre
     * @Table annoation when paring
     * @param className the name of entity class
     * @return true if need to igonre
     */
    public boolean ignoreTableAnn(String unitName, String className);

    /**
     * build to entity table metadata
     * @param className the name of entity class
     */
    public void buildTable(String unitName, String className);
}
