/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.strategy;

/**
 * the strategy for version field or property of an entity class that serves as
 * its optimistic lock value.
 * @author Lin Liang
 */

public interface VersionStrategy {
    /**
     * compare two version
     * @param curObject current version value
     * @param newObject new version value
     * @return -1, 0, 1 for curObject older than, equal to, or newer than
     *         newObject
     */
    public int compareVersion(Object curObject, Object newObject);

    /**
     * generate the next version value
     * @param obj version value
     * @return the next version value
     */
    public Object nextVersion(Object obj);
}
