/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.strategy.discriminator;

import org.ow2.xplus.metadata.strategy.DiscriminatorStrategy;
import org.ow2.xplus.util.ClassStrategy;

/**
 * @author Lin Liang
 */

public class IntegerDiscriminatorStrategy implements DiscriminatorStrategy {

    public Object getValue(String className) {
        return new Integer(className.hashCode());
    }

    public String getSqlType() {
        return ClassStrategy.getSqlType(Integer.class);
    }

    public Class getJavaType() {
        return Integer.class;
    }

}