/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.strategy.value;

import org.ow2.xplus.metadata.strategy.ValueStrategy;

/**
 * @author Lin Liang
 */

@SuppressWarnings("unchecked")
public abstract class AbstractValueStrategy implements ValueStrategy {

    protected Class dataType;

    /**
     * the value to store in database
     */
    public Object getDataValue(Object value) {
        return value;
    }

    /**
     * the value for entity
     */
    public Object getObjectValue(Object value) {
        return value;
    }

    /**
     * get the type of value
     * @return the type of value
     */
    public Class getDataType() {
        return dataType;
    }

}
