/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.metadata.strategy.value;

import java.lang.reflect.Method;

/**
 * @author Lin Liang
 */

public class BasicValueStrategy extends AbstractValueStrategy {

    public BasicValueStrategy() {

    }

    /**
     * set the type of value
     * @param type
     */
    public void setDataType(Class dataType) {
        this.dataType = dataType;
    }

    /**
     * the value for entity
     */
    @Override
    public Object getObjectValue(Object value) {
        String typeName = dataType.getCanonicalName();
        int index = typeName.lastIndexOf(".");
        if (index > 0)
            typeName = typeName.substring(index);
        Method transMethod = null;
        try {
            transMethod = value.getClass().getMethod(typeName + "Value", new Class[] {});
        } catch (NoSuchMethodException e) {
            try {
                typeName = typeName.substring(0, 1).toUpperCase() + typeName.substring(1);
                transMethod = value.getClass().getMethod("to" + typeName, new Class[] {});
            } catch (NoSuchMethodException ne) {
            }
        }

        if (transMethod != null) {
            try {
                value = transMethod.invoke(value, new Object[] {});
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return value;
    }
}
