/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.operator;

import java.util.ArrayList;
import java.util.List;

import org.apache.ddlutils.platform.ModelBasedResultSetIterator;

/**
 * find all the entities required
 * @author Lin Liang
 */

public class Finder {

    private EntityCreator creator;

    public Finder(EntityCreator creator) {
        this.creator = creator;
    }

    /**
     * create a list of entities from ResultSet
     * @param type the class type of entity to be created
     * @param resultIter the ResultSet Iterator
     * @return a list of entities
     */
    @SuppressWarnings("unchecked")
    public List get(Class type, ModelBasedResultSetIterator resultIter) {
        List entities = creator.create(type, resultIter);

        List result = new ArrayList();
        for (Object entity : entities) {
            if (!result.contains(entity)) {
                result.add(entity);
            }
        }

        return result;
    }

}
