/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.operator;

import java.io.StringReader;

import javax.persistence.CascadeType;

import org.apache.ddlutils.io.DataReader;
import org.apache.ddlutils.io.DelFromDatabaseSink;

import org.ow2.xplus.deployer.DatabaseManager;

/**
 * remove entities from database
 * @author Lin Liang
 */

public class Remover {

    private EntityReader reader;

    public Remover(EntityReader reader) {
        this.reader = reader;
    }

    /**
     * remove the given entity from database
     * @param entity the entity to be removed
     * @param database the database
     */
    public void remove(Object entity, DatabaseManager database) {
        reader.read(entity, CascadeType.REMOVE, false);
        String dataXml = reader.getDataXML();

        DataReader dataReader = new DataReader();
        dataReader.setModel(database.getModel());
        dataReader.setSink(new DelFromDatabaseSink(database.getPlatform(), database.getModel()));
        try {
            dataReader.parse(new StringReader(dataXml));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
