/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.operator.accessor;

import org.apache.commons.beanutils.DynaBean;

import org.ow2.xplus.context.PersistenceContext;
import org.ow2.xplus.metadata.object.ClassMetaData;
import org.ow2.xplus.metadata.object.FieldMetaData;
import org.ow2.xplus.metadata.object.SimpleValue;

/**
 * @author Lin Liang
 */

public class BasicAccessor extends AbstractAccessor {

    public BasicAccessor(ClassMetaData classMetaData, FieldMetaData field) {
        super(classMetaData, field);
    }

    @SuppressWarnings("unchecked")
    public void obtainValue(Object fieldData) {
        if (fieldData == null)
            return;
        SimpleValue value = field.getValue().getSimpleValue();
        columns.clear();
        values.clear();
        columns.add(value.getColumns().get(0));
        values.add(fieldData);
    }

    public boolean save(Object entityData, Object fieldValue) {
        if (fieldValue == null)
            return false;
        Object value = getFieldValue(entityData, field.getFieldName());
        if (!fieldValue.equals(value)) {
            setFieldValue(entityData, field.getFieldName(), fieldValue);
            return true;
        }
        return false;
    }
    
    public boolean save4Copy(Object entityData , Object fieldValue){
    	if (fieldValue == null)
    		return false;
    	Object value = getFieldValue(entityData , field.getFieldName());
    	if(!fieldValue.equals(value)){
    		setFieldValue4Copy(entityData,field.getFieldName(),fieldValue);
    		return true;
    	}
    	return false;
    }

    public Object create(DynaBean bean, PersistenceContext context,Object entityData) {
        String columnName = field.getValue().getSimpleValue().getColumns().get(0).getName();

        return bean.get(columnName);
    }
    public Object create(Object oentity,PersistenceContext context,Object entityData) {
    	String fieldName = field.getFieldName();
    	
    	return getFieldValue(oentity,fieldName);
    }
}
