/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.operator.accessor;

import java.util.Collection;
import java.util.Map;

import org.ow2.xplus.metadata.object.ClassMetaData;
import org.ow2.xplus.metadata.object.FieldMetaData;

/**
 * @author Lin Liang
 */

public class MapVisitor extends AbstractVisitor {

    public Collection getCollection(Object data) {
        Map mapData = (Map) data;
        return mapData.values();
    }

    @SuppressWarnings("unchecked")
    public void addToCollection(Object entityData, FieldMetaData field, Object value, ClassMetaData valueClassMetaData) {

        Object fieldValue = getFieldValue(entityData, field.getFieldName());

        saveWithCheckForExistence(fieldValue, field, value, valueClassMetaData);

        setFieldValue(entityData, field.getFieldName(), fieldValue);

    }

    @SuppressWarnings("unchecked")
    private void saveWithCheckForExistence(Object fieldValue, FieldMetaData field, Object valueToAdd,
            ClassMetaData valueClassMetaData) {
        Object valueToAddId = getIdValue(valueToAdd, valueClassMetaData);

        for (Object collectionValue : getCollection(fieldValue)) {
            Object collectionValueId = getIdValue(collectionValue, valueClassMetaData);
            if (collectionValueId.equals(valueToAddId)) {
                String mapKey = field.getValue().getCollectionValue().getMappedPropertyName();
                Object mapKeyValue = getFieldValue(collectionValue, mapKey);
                ((Map) fieldValue).remove(mapKeyValue);
                break;
            }
        }

        String mapKey = field.getValue().getCollectionValue().getMappedPropertyName();
        Object mapKeyValue = getFieldValue(fieldValue, mapKey);

        ((Map) fieldValue).put(mapKeyValue, fieldValue);
    }

}
