/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.query;

import java.io.StringReader;

import antlr.RecognitionException;
import antlr.TokenStreamException;
import org.ow2.xplus.metadata.UnitMetaData;
import org.ow2.xplus.query.ejbql.EJBQLTree;
import org.ow2.xplus.query.ejbql.antlr.EJBQLLexer;
import org.ow2.xplus.query.ejbql.antlr.EJBQLParser;
import org.ow2.xplus.query.ejbql.tree.Node;
import org.ow2.xplus.query.ejbql.tree.QueryNode;

/**
 * used to build sql expr
 * @author Lin Liang
 */

public class ExpressionBuilder {

    private UnitMetaData unit;

    public ExpressionBuilder(UnitMetaData unit) {
        this.unit = unit;
    }

    public Node buildQueryExpression(String ejbql) {
        EJBQLLexer ejbqlLexer = new EJBQLLexer(new StringReader(ejbql));
        EJBQLParser ejbqlParser = new EJBQLParser(ejbqlLexer);
        try {
            ejbqlParser.statement();
        } catch (RecognitionException e) {
            e.printStackTrace();
        } catch (TokenStreamException e) {
            e.printStackTrace();
        }
        QueryNode root = ejbqlParser.getRoot();

        EJBQLTree tree = new EJBQLTree(unit);
        root.setTree(tree);
        tree.setRoot(root);

        return root;
    }
}
