/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.query.dialect;

/**
 * @author Lin Liang
 */

public class GenericDialect implements Dialect {

    public String getDeclaration(String tableName, String tableId) {
        return "\"" + tableName + "\" " + tableId + " ";
    }

    public String getDelDeclaration(String tableName, String tableId) {
        return "\"" + tableName + "\" " ;
    }
    
    public String getColumnName(String columnName) {
        return "\"" + columnName + "\"";
    }

    public String getIdFromDeclaration(String declaration) {
        String id = declaration.substring(declaration.indexOf(' ') + 1);
        if (id.indexOf(' ') > 0)
            id = id.substring(0, id.indexOf(' '));

        return id;
    }

    public String getNameFromDeclaration(String declaration) {
        String tableName = declaration.substring(declaration.indexOf('\"') + 1);
        tableName = tableName.substring(0, tableName.indexOf('\"'));
        return tableName;
    }
}
