/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.query.ejbql.tree;

import java.util.List;

/**
 * @author Lin Liang
 */

public class AnyAllExprNode extends AbstractNode {

    String operator = "";

    Node subquery = null;

    public AnyAllExprNode(List args) {
        super(args);

        operator = (String) args.get(0);
        subquery = (Node) args.get(1);
    }

    @Override
    public void process() {
        if (processed)
            return;

        subquery.setRoot(getRoot());
        subquery.process();

        super.process();
    }

    public String toSQLString() {
        return operator + "(" + subquery.toSQLString() + ")";
    }

}
