/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.query.ejbql.tree;

import java.util.List;

import org.ow2.xplus.metadata.UnitMetaData;

/**
 * @author Lin Liang
 */

public class CollectionMemberDeclarationNode extends AbstractNode {

    private PathExprNode pathExpr = null;

    private String ident;

    private String tableName;

    public CollectionMemberDeclarationNode(List args) {
        super(args);

        pathExpr = (PathExprNode) args.get(0);
        ident = (String) args.get(1);
    }

    @Override
    public void process() {
        if (processed)
            return;

        pathExpr.setRoot(getRoot());
        pathExpr.setIdent(ident);
        pathExpr.process();

        Class idType = pathExpr.getIdType();

        UnitMetaData unit = getRoot().getTree().getUnit();
        tableName = unit.findClassMetaData(idType.getCanonicalName()).getPrimaryTableName();
        // getRoot().getFrom().addDeclaration(tableName, ident);
        getRoot().getFrom().addCollectionMemberDeclaration(tableName, ident);
        getRoot().getTree().addDeclaration(ident, idType);

        super.process();
    }

    public String toSQLString() {
        return "";
        //return " " + tableName + " " + ident;
    }

}
