/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.query.ejbql.tree;

import java.util.List;

/**
 * @author Lin Liang
 */

public class ConcatNode extends AbstractNode {

    private Node firstArg, secondArg;

    public ConcatNode(List args) {
        super(args);

        firstArg = (Node) args.get(0);
        secondArg = (Node) args.get(1);
    }

    @Override
    public void process() {
        if (processed)
            return;

        firstArg.setRoot(getRoot());
        firstArg.process();
        secondArg.setRoot(getRoot());
        secondArg.process();

        super.process();
    }

    public String toSQLString() {
        return " CONCAT (" + firstArg.toSQLString() + secondArg.toSQLString() + ") ";
    }

}
