/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.query.ejbql.tree;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Lin Liang
 */

public class ConditionalTermNode extends AbstractNode {

    private List<Node> factors = new ArrayList<Node>();

    public ConditionalTermNode(List args) {
        super(args);

        for (Object factor : args) {
            factors.add((Node) factor);
        }
    }

    @Override
    public void process() {
        if (processed)
            return;

        for (Node factor : factors) {
            factor.setRoot(getRoot());
            factor.process();
        }

        super.process();
    }

    public String toSQLString() {
        StringBuilder expr = new StringBuilder(1024);

        int size = factors.size();
        expr.append(factors.get(0).toSQLString());

        for (int index = 1; index < size; ++index) {
            expr.append(" AND ");
            expr.append(factors.get(index).toSQLString());
        }

        return expr.toString();
    }

}
