/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.query.ejbql.tree;

import java.util.List;

import org.ow2.xplus.query.utils.NameGenerator;

/**
 * @author Lin Liang
 */

public class FetchJoinNode extends AbstractNode {

    private Boolean outerJoin = new Boolean(false);

    private PathExprNode pathExpr;

    private String ident;

    public FetchJoinNode(List args) {
        super(args);

        outerJoin = (Boolean) args.get(0);
        pathExpr = (PathExprNode) args.get(1);
        ident = (args.size() == 2) ? NameGenerator.getTableName() : (String) args.get(2);
    }

    @Override
    public void process() {
        if (processed)
            return;

        pathExpr.setRoot(getRoot());
        pathExpr.process();

        super.process();
    }

    public String toSQLString() {
        StringBuilder join = new StringBuilder(1024);

        String outer = outerJoin.booleanValue() ? " LEFT OUTER JOIN" : " INNER JOIN ";
        join.append(outer);

        join.append(pathExpr.toSQLString());
        join.append(" AS ");
        join.append(ident);

        getRoot().getTree().addDeclaration(ident, pathExpr.getIdType());

        return join.toString();
    }

}
