/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.query.ejbql.tree;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Lin Liang
 */

public class IdVarDeclarationNode extends AbstractNode {

    private RangeVarDeclarationNode rangeVar;

    private List<Node> joins = new ArrayList<Node>();

    public IdVarDeclarationNode(List args) {
        super(args);

        rangeVar = (RangeVarDeclarationNode) args.get(0);

        for (int index = 1; index < args.size(); ++index) {
            joins.add((Node) args.get(index));
        }
    }

    @Override
    public void process() {
        if (processed)
            return;

        rangeVar.setRoot(getRoot());
        rangeVar.process();
        for (Node join : joins) {
            join.setRoot(getRoot());
            join.process();
        }

        super.process();
    }

    public String toSQLString() {
        StringBuilder IdVarDecl = new StringBuilder(1024);

        IdVarDecl.append(rangeVar.toSQLString());
        for (Node join : joins) {
            IdVarDecl.append(" ");
            IdVarDecl.append(join.toSQLString());
        }

        return IdVarDecl.toString();
    }

}
