/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.query.ejbql.tree;

import java.util.List;

/**
 * @author Lin Liang
 */

public class LocateNode extends AbstractNode {

    private Node str, pattern, startPos;

    public LocateNode(List args) {
        super(args);

        str = (Node) args.get(0);
        pattern = (Node) args.get(1);
        startPos = (args.size() == 2) ? null : (Node) args.get(2);
    }

    @Override
    public void process() {
        if (processed)
            return;

        str.setRoot(getRoot());
        str.process();
        pattern.setRoot(getRoot());
        pattern.process();
        if (startPos != null) {
            startPos.setRoot(getRoot());
            startPos.process();
        }

        super.process();
    }

    public String toSQLString() {
        StringBuilder locate = new StringBuilder(1024);
        locate.append("LOCATE (");
        locate.append(str.toSQLString());
        locate.append(", ");
        locate.append(pattern.toSQLString());
        if (startPos != null) {
            locate.append(", ");
            locate.append(startPos.toSQLString());
        }
        locate.append(") ");
        return locate.toString();
    }

}
