/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.query.ejbql.tree;

import java.util.List;

import org.ow2.xplus.query.utils.NameGenerator;
import org.ow2.xplus.util.ClassStrategy;

/**
 * @author Lin Liang
 */

public class RangeVarDeclarationNode extends AbstractNode {

    private String schema, id;

    private String tableName;

    private Class idType;

    public RangeVarDeclarationNode(List args) {
        super(args);

        schema = (String) args.get(0);
        id = (args.size() == 2) ? (String) args.get(1) : NameGenerator.getTableName();
    }

    @Override
    public void process() {
        if (processed)
            return;

        String idTypeName = getRoot().getTree().getUnit().findEntityName(schema);
        idType = ClassStrategy.forName(idTypeName);
        tableName = getRoot().getTree().getUnit().findClassMetaData(idTypeName).getPrimaryTableName();
        getRoot().getTree().addDeclaration(id, idType);

        super.process();
    }

    public Class getIdType() {
        return idType;
    }

    public String toSQLString() {
        return getRoot().getTree().getDialect().getDeclaration(tableName, id);
    }

}
