/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.query.ejbql.tree;

import java.util.List;

/**
 * @author Lin Liang
 */

public class TrimNode extends AbstractNode {

    private Node string, trimChar = null;

    private String trimSpec = null;

    public TrimNode(List args) {
        super(args);

        if (args.size() == 1) {
            string = (Node) args.get(0);
        } else {
            trimSpec = (String) args.get(0);
            trimChar = (Node) args.get(1);
            string = (Node) args.get(2);
        }
    }

    @Override
    public void process() {
        if (processed)
            return;

        if (trimChar != null) {
            trimChar.setRoot(getRoot());
            trimChar.process();
        }
        string.process();

        super.process();
    }

    public String toSQLString() {
        StringBuilder trim = new StringBuilder(1024);

        trim.append("TRIM(");
        if (trimChar != null) {
            trim.append(trimSpec).append(" ").append(trimChar.toSQLString()).append(" FROM");
        }
        trim.append(string.toSQLString());
        trim.append(")");

        return null;
    }

}
