/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.query.ejbql.tree;

import java.util.List;

/**
 * @author Lin Liang
 */

public class UpdateQueryNode extends QueryNode {

    private Node update, set;

    public UpdateQueryNode(List args) {
        super(args);

        update = (Node) args.get(0);
        set = (Node) args.get(1);

        if (args.size() > 2)
            where = (WhereNode) args.get(2);
    }

    @Override
    public void process() {
        if (processed)
            return;

        update.setRoot(getRoot());
        update.process();
        set.setRoot(getRoot());
        set.process();

        if (where != null) {
            where.setRoot(getRoot());
            where.process();
        }

        super.process();
    }

    @Override
    public String toSQLString() {
        StringBuilder updateQuery = new StringBuilder(1024);

        updateQuery.append(update.toSQLString());
        updateQuery.append(" SET ");
        updateQuery.append(set.toSQLString());

        if (where != null) {
            updateQuery.append(" ");
            updateQuery.append(where.toSQLString());
        }

        return updateQuery.toString();
    }
	/**
	 * added by yuanfeng 2007-2-21
	 */
	
   public boolean hasWhere(){
	   if(where==null)return false;
	   else return true;
   }
   public UpdateNode getUpdate(){
	   return (UpdateNode)update;
   }
	
   public String getWherePart(){
	   if(where!=null)
	   {
	   return (where.toSQLString());
	   }
	   return null;
   }
}
