/* -------------------------------------------------------------------------*
 * PKUAS: Peking University Application Server
 * Copyright (C) 2006 Peking University
 *
 * This software is free; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * either version 2.1 or any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 * ------------------------------------------------------------------------*/

package org.ow2.xplus.transaction;

import org.ow2.xplus.broker.PersistenceManager;

/**
 * @author Lin Liang
 */

public class TransactionFactory {

    private TxManager txMgr = null;

    public TransactionFactory(String txMgrName) {
        try {
            txMgr = (TxManager) Class.forName(txMgrName).newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    synchronized public PersistenceTransaction getTranscation(PersistenceManager pm) {
        PersistenceTransaction tx = new PersistenceTransaction(txMgr.getTransactionManager(), pm);
        return tx;
    }
}
